#include <glylib.h>
#include <AMBER/amber.h>


molecule clean_sugar(assembly *IS){

molecule S;
molecule E;
int mi,ri,ccheck=0;
//initialize_assembly(&N);
char *SLfile;
fileset SLset;
SLfile=(char*)calloc(10,sizeof(char));
sprintf(SLfile,"sugar.log");
char *Lfile;
Lfile=(char*)calloc(17,sizeof(char));
sprintf(Lfile,"log_residues.pdb");
fileset Lset;
Lset.N=strdup(Lfile);
Lset.F=myfopen(Lset.N,"w");
SLset.N=strdup(SLfile);
SLset.F=myfopen(SLset.N,"w");
fprintf(SLset.F,"ResidueName\tResidueNumber\n");

S.nr=0;
S.r=(residue*)calloc(0,sizeof(residue));
E.nr=0;
E.r=(residue*)calloc(0,sizeof(residue));

//printf("The number of molecules in assembly N are %d\n",N.nm);

for(mi=0;mi<IS[0].nm;mi++){
	//printf("The number of carbohydrate residues are %d\n",IS[0].m[mi][0].nr);
	for(ri=0;ri<IS[0].m[mi][0].nr;ri++){
		/* If there are more than 5 atoms then copy them into a new molecule*/
		if(IS[0].m[mi][0].r[ri].na>5){
			S.nr++;
			S.r=(residue*)realloc(S.r,(S.nr*sizeof(residue)));
			S.r[S.nr-1]=IS[0].m[mi][0].r[ri];
		}
		if(IS[0].m[mi][0].r[ri].na<=5){
			E.nr++;
			E.r=(residue*)realloc(E.r,(E.nr*sizeof(residue)));
			E.r[E.nr-1]=IS[0].m[mi][0].r[ri];
			//printf("FOUND SOME RESIDUES WITH LESS THAN FIVE ATOMS!!I DONT THINK THIS IS A SUGAR!! PLEASE CHECK THE sugar.log FILE\n");
			fprintf(SLset.F,"%s\t\t%d\n",IS[0].m[mi][0].r[ri].N,IS[0].m[mi][0].r[ri].n);
			ccheck++;
		}
		
	}
}
fclose(SLset.F);

if(ccheck>0){
	//printf("The total number of carbohydrate residues that will be anlayzed are %d\n",IS[0].m[0][0].nr-ccheck);
}

//printf("The nnumber of residues are %d\n",S.nr);
//printf("Lset is <<<%s>>>>\n",Lset.N);
if(E.nr>=1){
outputMolPDB(&E,Lset.N);
}

return S;
}
