#include <glylib.h>
#include <AMBER/amber.h>

typedef struct {
	int n; /**< number of atoms */
	char **N;
} natoms;


natoms* detect_cycle(residue S){

int i=0,j=1,k=0,l=0,m=0,n=0,ai=0,check=0,rsize=0,csize=0,nsize=0,casize=0,nbonds=0,cbonds=0,rcheck=0,ccheck=0,test=0;
coord_3D distances;
vectormag_3D temp_blength;
char *atomname;
atomname=(char*)calloc(5,sizeof(char));
char *tempatomname;
tempatomname=(char*)calloc(5,sizeof(char));
char **root_atoms;
root_atoms=(char**)calloc(0,sizeof(char*));
char **connecting_atoms;
connecting_atoms=(char**)calloc(0,sizeof(char*));
char **temp_catoms;
temp_catoms=(char**)calloc(0,sizeof(char*));
char **cycle_atoms;
cycle_atoms=(char**)calloc(0,sizeof(char*));
int *temp_anum;
temp_anum=(int*)calloc(0,sizeof(int));
int *bonds;
bonds=(int*)calloc(0,sizeof(int));
//printf("here\n");
natoms* new=(natoms*)calloc(1,sizeof(natoms));
(*new).n=0;
(*new).N=(char**)calloc(0,sizeof(char*));
//printf("the number of natoms in  the function are %d\n",new[0].n);


while(i<j){
	//printf("inside while\n");
	if(i==0){ //getting the connecting atoms of the first atom 
		rsize++;
		root_atoms=(char**)realloc(root_atoms,(0+rsize*sizeof(char*)));
		root_atoms[rsize-1]=strdup(S.a[i].N);
		//printf("The root atoms are %s\n",root_atoms[rsize-1]);
		for(ai=0;ai<S.na;ai++){
			//printf("S.a[ai].N is %s and S.a[i].N is %s\n",S.a[ai].N,S.a[i].N);
			if(strcmp(S.a[ai].N,S.a[i].N) != 0){
				//printf("inside if\n");
				distances=subtract_coord(S.a[ai].x,S.a[i].x);
				temp_blength=coord_to_vec(distances);
				if(temp_blength.d<=1.65 && strncmp(S.a[ai].N,"H",1)!= 0){
					csize++;
					connecting_atoms=(char**)realloc(connecting_atoms,(0+csize*sizeof(char*)));
					connecting_atoms[csize-1]=strdup(S.a[ai].N);
					temp_catoms=(char**)realloc(temp_catoms,(csize*sizeof(char*)));
					temp_catoms[csize-1]=strdup(S.a[ai].N);
					temp_anum=(int*)realloc(temp_anum,(csize*sizeof(int)));
					temp_anum[csize-1]=ai;
					nbonds++;
				}
			}
		}
				
		nsize++;
		bonds=(int*)realloc(bonds,(nsize*sizeof(int)));
		bonds[nsize-1]=nbonds;
				
		//printf("connecting atom num is %d and atom is %s\n",csize-1,connecting_atoms[csize-1]);
		for(m=0;m<csize;m++){
			//printf("m is %d and c is %d\n",m,csize);
			//printf("connecting atoms are %s\n",connecting_atoms[m]);
		}
				

		k=csize-nbonds;
		//printf("k is %d\n",k);
		l=0;
		check=0;
		//printf("csize is %d\n",csize);
		while(l<csize){
			for(m=0;m<csize;m++){
				if(m!=l){
					if(strcmp(connecting_atoms[l],connecting_atoms[m]) == 0){
						check=1;
						atomname=strdup(connecting_atoms[l]);
					}
				}
			}
			l++;
		}
		//printf("atomname is %s\n",atomname);
		//printf("k is %d,n bonds is %d and check is %d\n",k,nbonds,check);

	}//if(i==0)

	//printf("atomname is %s\n",atomname);
			
	if(i>0){
		cbonds=0;
		int p=0,sum=0,val=0,q=0,r=0,temp_k=0;
		while(k<nbonds){
			//printf("temp_catom is %s\n",temp_catoms[k]);
			int ibonds=0;
			p=0,sum=0,val=0;
			while(p<nsize){
				sum=sum+bonds[p];
				if(sum >=k+1 || bonds[p]>= k+1){
					//printf("sum is %d,k+1 is %d and bonds[p] is %d and %d\n",sum,k+1,p,bonds[p]);
					val=bonds[p];
					if(q!=p){
						q=p;
						r=k+bonds[p];
						temp_k=k;
						//printf("q is %d\n",q);
					}
                                        //printf("printf k is %d and val is %d\n",k,val);
					p=nsize;
				}
				p++;
			}	

		//printf("r is %d and temp_k is %d\n",r,temp_k);

			for(ai=0;ai<S.na;ai++){
				n=0;
				rcheck=0;
				ccheck=0;
				while(n<rsize){
					if(strcmp(S.a[ai].N,root_atoms[n]) == 0){
						//printf("%s and %s\n",A[0].m[mi][0].r[ri].a[ai].N,root_atoms[n]);
						rcheck=1;
					}
				n++;
				}
				int temp_k1=temp_k;
				while(temp_k1<r){
					//printf("%s and %s\n",A[0].m[mi][0].r[ri].a[ai].N,temp_catoms[temp_k1]);
					if(strcmp(S.a[ai].N,temp_catoms[temp_k1]) == 0){
						ccheck=1;
					}
					temp_k1++;
				}								


				if(strcmp(S.a[ai].N,temp_catoms[k]) !=0 && ccheck==0 && rcheck==0){
					distances=subtract_coord(S.a[ai].x,S.a[temp_anum[k]].x);
					temp_blength=coord_to_vec(distances);
					if(temp_blength.d<=1.65 && strncmp(S.a[temp_anum[k]].N,"H",1) != 0){
						csize++;
						connecting_atoms=(char**)realloc(connecting_atoms,(0+csize*sizeof(char*)));
						connecting_atoms[csize-1]=strdup(S.a[ai].N);
						//printf("A[0].m[%d][0].r[%d].a[%d].N is >>>%s<<<\n",mi,ri,ai,A[0].m[mi][0].r[ri].a[ai].N);
						//printf("connecting atoms num is %d and atom is %s\n",csize-1,connecting_atoms[csize-1]);
						temp_catoms=(char**)realloc(temp_catoms,(csize*sizeof(char*)));
						temp_catoms[csize-1]=strdup(S.a[ai].N);
						temp_anum=(int*)realloc(temp_anum,(csize*sizeof(int)));
						temp_anum[csize-1]=ai;
						cbonds++;
						ibonds++;
					}
				}
			}
			if(ibonds>0){
				rsize++;
				//printf("rsize is %d\n",rsize);
				root_atoms=(char**)realloc(root_atoms,(rsize*sizeof(char*)));	
				root_atoms[rsize-1]=strdup(temp_catoms[k]);
				//printf("root_atoms are %s\n",root_atoms[rsize-1]);
				nsize++;
				bonds=(int*)realloc(bonds,(nsize*sizeof(int)));
				bonds[nsize-1]=ibonds;
			}
			k++;
			//printf("csize is %d\n",csize);
		}//whilek

		for(m=0;m<csize;m++){
			//printf("done with while connecting atoms are %s\n",connecting_atoms[m]);
		}

		l=0;
		check=0;
		//printf("csize is %d\n",csize);
		while(l<csize){
			for(m=0;m<csize;m++){
				if(m!=l){
					//printf("connecting_atoms[l] is %s and connecting_atoms[m] is %s\n",connecting_atoms[l],connecting_atoms[m]);
					if(strcmp(connecting_atoms[l],connecting_atoms[m]) == 0){
						check=1;
						atomname=strdup(connecting_atoms[l]);
					}
				}
			}
			l++;
		}//whilel
		if(check==0){
			nbonds=csize;
			k=csize-cbonds;
		}
		if(check==1){
			k=nbonds;
		}
		//printf("check is %d,k is %d,nbonds is %d\n",check,k,nbonds);
			
	}//if(i>0)		

	if(check==0){
		if(i>10){
			i=j;
			test=1;
			
		}
		else{
		i++;
		j=i+1;
		}
	}
	if(check==1){
		i=j;
	}
	//printf("i is %d and j is %d\n",i,j);
}//while

//printf("doone wiht main loop\n");

i=0;
while(i<rsize){
	//printf("root atoms are %s\n",root_atoms[i]);
	i++;
}

i=0;
while(i<csize){
//	printf("connecting atoms are %s\n",connecting_atoms[i]);
	i++;
}

i=0;
while(i<nsize){
	//printf("nbonds are %d\n",bonds[i]);
i++;
}

//printf("atom name is %s\n",atomname);
//printf("done with testing\n");
	
int ival=0,track=0,acsize=0,bcsize=0,pcheck=0;
i=0;
j=0;
char **pathA;
pathA=(char**)calloc(0,sizeof(char*));
char **pathB;
pathB=(char**)calloc(0,sizeof(char*));
if(test==0){
while(i<csize){
	//printf("i is %d\n",i);
	if(strcmp(connecting_atoms[i],atomname) == 0){
		pcheck++;
		if(pcheck==1){
			acsize++;
			pathA=(char**)realloc(pathA,(acsize*sizeof(char*)));
			pathA[acsize-1]=strdup(atomname);
		}
		if(pcheck>1){
			bcsize++;
			pathB=(char**)realloc(pathB,(bcsize*sizeof(char*)));
			pathB[bcsize-1]=strdup(atomname);
		}
		//printf("atom %s found and i is %d\n",atomname,i);
		ival= i+1;
		j=0;
		track=0;
		while(j<nsize){
			track=track+bonds[j];
			if(track >= ival || bonds[j] >= ival){
				tempatomname=strdup(root_atoms[j]);
				if(pcheck==1){
					acsize++;
					pathA=(char**)realloc(pathA,(acsize*sizeof(char*)));
					pathA[acsize-1]=strdup(tempatomname);
				}
				if(pcheck>1){
					bcsize++;
					pathB=(char**)realloc(pathB,(bcsize*sizeof(char*)));
					pathB[bcsize-1]=strdup(tempatomname);
				}
				//printf("root atoms is %s\n",root_atoms[j]);
				k=0;
				j=nsize;
				while(k<csize){
					if(strcmp(connecting_atoms[k],tempatomname) == 0){
						ival=k+1;
						k=csize;
						track=0;
						j=0;
					}
					k++;
				
				}
				
			}
			else{
				j++;
			}

		}
	}

	i++;
}

//printf("done with second while\n");
i=0;
while(i<acsize){
	//printf("pathA are %s\n",pathA[i]);
	i++;
}

i=0;
while(i<bcsize){
	//printf("pathB are %s\n",pathB[i]);
	i++;
}

i=1;
int Aval=0,Bval=0;
//char **cycle_atoms;
//cycle_atoms=(char**)calloc(0,sizeof(char*));
casize++;
(*new).n++;
cycle_atoms=(char**)realloc(cycle_atoms,(casize*sizeof(char*)));
cycle_atoms[casize-1]=strdup(pathA[0]);
(*new).N=(char**)realloc((*new).N,(casize*sizeof(char*)));
(*new).N[casize-1]=strdup(pathA[0]);
while(i<acsize){
	//printf("The atom is %s\n",pathA[i]);
	j=0;
	while(j<bcsize){
		if(strcmp(pathA[i],pathB[j]) == 0){
			//printf("atoms %s and %s match\n",pathA[i],pathB[j]);
			//printf("%d and %d\n",i,j);
			Aval=i;
			Bval=j+1;
			j=bcsize;
			i=acsize;
		}
		j++;
	}
i++;
}



for(i=1;i<Aval;i++){
	(*new).n++;
	casize++;
	cycle_atoms=(char**)realloc(cycle_atoms,(casize*sizeof(char*)));
	cycle_atoms[casize-1]=strdup(pathA[i]);
	(*new).N=(char**)realloc((*new).N,(casize*sizeof(char*)));
	(*new).N[casize-1]=strdup(pathA[i]);
	//printf("The atoms in a cycle in pathA are %s\n",pathA[i]);
}

for(j=1;j<Bval;j++){
	(*new).n++;
	casize++;
        cycle_atoms=(char**)realloc(cycle_atoms,(casize*sizeof(char*)));
        cycle_atoms[casize-1]=strdup(pathB[j]);
	(*new).N=(char**)realloc((*new).N,(casize*sizeof(char*)));
	(*new).N[casize-1]=strdup(pathB[j]);
	//printf("The atoms in a cycle in pathB are %s\n",pathB[j]);
}

//printf("new.n is %d\n",new.n);

for(i=0;i<casize;i++){
	//printf("The atoms in new are %s\n",new.N[i]);
}

for(i=0;i<casize;i++){
	//printf("The atoms in a cycle are %s\n",cycle_atoms[i]);
}
}//test==0


//printf("new.n is %d\n",new.n);
return new;

}
