#include <glylib.h>

typedef struct {
        int n; /**< number of atoms */
        char **N;
} natoms;

typedef struct{
        char *O;
        char *C;
        char *R;
        char *Ra;
        char *RN;
        int Rn;
} cxns;

natoms* sort_atoms(natoms* new,cxns* anomeric,coord_3D *cycle_coords){


int i=0,j=0,k=0;
int atomno=0;
//vectormag_3D temp_blength;
vectormag_3D distances;
initialize_vectormag_3D(&distances);


for(i=0;i<new[0].n;i++){
	//printf("The atom name is %s",new[0].N[i]);
	//dprint_coord_3D(&cycle_coords[i]);
	if(strstr(new[0].N[i],anomeric[0].C) != NULL){
		atomno=i;
		//printf("The atom name is %s\n",new[0].N[i]);
		//dprint_coord_3D(&cycle_coords[i]);
	}
}
//printf("done\n");

natoms* sortedatoms;
sortedatoms=(natoms*)calloc(1,sizeof(natoms));
(*sortedatoms).n=new[0].n;
(*sortedatoms).N=(char**)calloc(new[0].n,sizeof(char*));
//sortedatoms.n=new[0].n;
//sortedatoms.N=(char**)realloc(sortedatoms.N,(0+sortedatoms.n*sizeof(char*)));

(*sortedatoms).N[0]=strdup(anomeric[0].C);
//printf("new[0].n is %d\n",new[0].n);
//printf("anomeric.C is %s\n",anomeric.C);
//printf("done\n");
i=0;
j=1;
k=0;
int l=0;
int size=0;
/*char *tempatom=NULL;
tempatom=(char*)calloc(5,sizeof(char));*/
int tempsize=0;
int check=0;
while(i<j){
	//printf("inside while\n");
	k=0;
	//printf("inside while\n");
	while(k<new[0].n){
		check=0;
		if(strstr(new[0].N[k],"O") == NULL){
			distances=coord_to_vec(subtract_coord(cycle_coords[atomno],cycle_coords[k]));
			//printf("checking distances from atom %s\n",new[0].N[atomno]);
			//printf("atom %s",new[0].N[k]);
			//printf("The distances are %f\n",distances.d);
			if(distances.d<=1.65 && distances.d != 0.00){
				//tempatom=strdup(new[0].N[k]);
				//printf("The distances are %f ",distances.d);
				//printf("to atom name is %s\n",new[0].N[k]);
				if(i==0){
					check=0;
					//printf("i is %d\n",i);
					size++;
					//atomname=strdup(tempatom);	
					atomno=k;
					(*sortedatoms).N[size]=strdup(new[0].N[k]);
				}
				if(i>0){
					//printf("i is %d\n",i);
					for(l=0;l<tempsize;l++){
						//printf("tempatom is %s sortedatoms.N[l] is %s\n",tempatom,sortedatoms.N[l]);
						if(strstr(new[0].N[k],(*sortedatoms).N[l]) != NULL){
						check=1;
						}
					}
						
					if(check==0){
							//atomname=strdup(tempatom);
							size++;
							atomno=k;
							//printf("k is %d\n",k);
							(*sortedatoms).N[size]=strdup(new[0].N[k]);
						
					}
				
				}
				//printf("size is %d\n",size);	
				if(check==0){
	                        tempsize=size+1;
        	                k=new[0].n;
        	        }

			}				
				
		}
		//printf("check is %d\n",check);


	k++;		
	}

	if(size<new[0].n-2){
		i++;
		j++;
	}
	else{
		i++;
	}
	
}	

(*sortedatoms).N[new[0].n-1]=strdup(anomeric[0].O);
//printf("done\n");

return sortedatoms;
}
