#include <glylib.h>
#include <AMBER/amber.h>

void extract_models(fileslurp Fslurp){


int i=0,j=0,modelcheck=0;
fileset Oset;
Oset.N=strdup("all.pdb");
Oset.F=myfopen(Oset.N,"w");
for(i=0;i<Fslurp.n;i++){
	if(strncmp(Fslurp.L[i],"MODEL",5) == 0){
		modelcheck++;
		//printf("found %s",Fslurp.L[i]);
	}

}

//printf("The number of models are %d\n",modelcheck);

if(modelcheck>0){
	i=0;
	while(i<Fslurp.n){
		if(strncmp(Fslurp.L[i],"MODEL",5) == 0){
			i++;
			j=i;
			while(j<Fslurp.n){
				//printf("<<%s>>",Fslurp.L[j]);
				if(strncmp(Fslurp.L[j],"ENDMDL",6) == 0){
					//printf("here\n");
					j=Fslurp.n;
					i=Fslurp.n;
				}
				else{
					if(strncmp(Fslurp.L[j],"ATOM",4) == 0 || strncmp(Fslurp.L[j],"HETATM",6) == 0 || strncmp(Fslurp.L[j],"TER",3) == 0){
						if(strstr(Fslurp.L[j],"HOH") == NULL){
						//printf("%s",Fslurp.L[j]);
						fprintf(Oset.F,"%s",Fslurp.L[j]);
						}
					}
				}
			j++;
			}
		}
		i++;
	}

}	


if(modelcheck==0){
	for(i=0;i<Fslurp.n;i++){
		if(strncmp(Fslurp.L[i],"ATOM",4) == 0 || strncmp(Fslurp.L[i],"HETATM",5) == 0 || strncmp(Fslurp.L[i],"TER",3) == 0){
			if(strstr(Fslurp.L[i],"HOH") == NULL){
				//printf("%s",Fslurp.L[i]);
				fprintf(Oset.F,"%s",Fslurp.L[i]);
			}
		}
	}
}		

fclose(Oset.F);

}
