#include<glylib.h>

typedef struct {
        int n;
        char **N;
}natoms;

typedef struct{
        char *O;
        char *C;
        char *R;
        char *Ra;
        char *RN;
        int Rn;
}cxns;


typedef struct{
        char *sugar_type;
        char sugar_code[100];
        char *deoxy;
}sugarname;


typedef struct{
        int n;/*residue number of the connecting residue*/
        char *link_atom ;

}links;

links* identify_linkage(residue S,molecule M,cxns* anomeric,natoms* new){

links* linkcards;
linkcards=(links*)calloc(1,sizeof(links));
(*linkcards).n=0;
(*linkcards).link_atom=(char*)calloc(10,sizeof(linkcards));
strcpy(linkcards[0].link_atom,"NULL");

int ri=0,ai=0,i=0,j=0,k=0,lcheck=0,ccheck=0,tcheck=0;
vectormag_3D distances;
initialize_vectormag_3D(&distances);
//printf("residue number is %d\n",S.n);
//printf("anomeric.C is %s\n",anomeric[0].C);

while(i<S.na){
	if(strcmp(S.a[i].N,anomeric[0].C) == 0){
		for(ri=0;ri<M.nr;ri++){
			if(M.r[ri].n != S.n){
			for(ai=0;ai<M.r[ri].na;ai++){
				distances=coord_to_vec(subtract_coord(S.a[i].x,M.r[ri].a[ai].x));
				if(distances.d <=1.9 && strncmp(M.r[ri].a[ai].N,"H",1) != 0){
					//printf("%s\n",M.r[ri].a[ai].N);	
					//printf("%d\n",M.r[ri].n);
					lcheck=1;
					(*linkcards).n = M.r[ri].n;
					strcpy((*linkcards).link_atom,M.r[ri].a[ai].N);
				}					
	
			}
			}
		}
		
		

	}
i++;
}


if(lcheck==0){
	//printf("inside if\n");
	for(i=0;i<S.na;i++){
		if(strcmp(S.a[i].N,anomeric[0].C) == 0){
			ccheck=0;
			for(j=0;j<S.na;j++){
				ccheck=0;
				for(k=0;k<new[0].n;k++){
					if(strcmp(S.a[j].N,new[0].N[k]) == 0){
						ccheck=1;
					}
				}
				if(ccheck==0){
					distances=coord_to_vec(subtract_coord(S.a[i].x,S.a[j].x));
					if(distances.d<=1.9 && strncmp(S.a[j].N,"H",1) != 0){
						//printf("checking distances between %s and %s\n",S.a[i].N,S.a[j].N);					

						tcheck=1;
						(*linkcards).n = S.n;
                                        strcpy((*linkcards).link_atom,S.a[j].N);
					}
				}
			}		
		}
	}
	
}


if(lcheck==0 && tcheck==0){
	(*linkcards).n = 0;
	strcpy((*linkcards).link_atom,"ROH/OME");
	//printf("The terminal residue is missing, add a ROH or OME\n");
}
return linkcards;
}
