#include<glylib.h>
#include<AMBER/amber.h>

molecule process_sugar(char* filename){

assembly *S;
//printf("before loading molecule\n");
S=load_pdb(filename);
//printf("loaded_molecule\n");
int mi,ri,ai,check=0,check1=0;
char *chainid=NULL;
//const char *ATOMLINE;
chainid=strdup("XX");
molecule sugar;
initialize_molecule(&sugar);
residue r;
initialize_residue(&r);

fileset Lset,SLset;
SLset.N=strdup("sugar.log");
SLset.F=myfopen(SLset.N,"w");
Lset.N=strdup("log_residues.pdb");
Lset.F=myfopen(Lset.N,"w");
fprintf(SLset.F,"ResidueName\tResidueNumber\n");

molecule temp_sugar;
initialize_molecule(&temp_sugar);
molecule E;
initialize_molecule(&E);
int pcheck=0;

for(mi=0;mi<S[0].nm;mi++){
	for(ri=0;ri<S[0].m[mi][0].nr;ri++){
		pcheck=0;
		for(ai=0;ai<S[0].m[mi][0].r[ri].na;ai++){
			if(strcmp(S[0].m[mi][0].r[ri].a[ai].N,"N") ==0){
				pcheck++;		
			}
			if(strcmp(S[0].m[mi][0].r[ri].a[ai].N,"CA") ==0){
				pcheck++;
                        }
			if(strcmp(S[0].m[mi][0].r[ri].a[ai].N,"CB") ==0){
				pcheck++;
                        }
			
		}
	if(pcheck>=3){
				

	}
	else{
		if(S[0].m[mi][0].r[ri].na>5){
		temp_sugar.nr++;
		temp_sugar.r=(residue*)realloc(temp_sugar.r,(temp_sugar.nr*sizeof(residue)));
		temp_sugar.r[temp_sugar.nr-1]=S[0].m[mi][0].r[ri];			
		}
		if(S[0].m[mi][0].r[ri].na<=5){
                E.nr++;
		E.r=(residue*)realloc(E.r,(E.nr*sizeof(residue)));
               	E.r[E.nr-1]=S[0].m[mi][0].r[ri];
		fprintf(SLset.F,"%s\t\t%d\n",S[0].m[mi][0].r[ri].N,S[0].m[mi][0].r[ri].n);               
                }


	}
			
	
	}	

}
fclose(SLset.F);


if(E.nr>=1){
	outputMolPDB(&E,Lset.N);
}

for(ri=0;ri<temp_sugar.nr;ri++){
	for(ai=0;ai<temp_sugar.r[ri].na;ai++){
	//printf("the atoms are %s\n", temp_sugar.r[ri].a[ai].N);
	}
}

	//printf(">>>>%d<<<<<\n",S[0].m[mi][0].nr);
	for(ri=0;ri<temp_sugar.nr;ri++){
		//printf("residue %d\n",ri);
		check=0;
		check1=0;
		chainid=strdup(temp_sugar.r[0].a[0].cID);
		r.na=0;
		r.a=(atom*)calloc(0,sizeof(atom));
		r.N=temp_sugar.r[ri].N;
		r.n=temp_sugar.r[ri].n;
		for(ai=0;ai<temp_sugar.r[ri].na;ai++){
				//printf("%s\n",temp_sugar.r[ri].a[ai].cID);
				//printf("%s\n",chainid);
			if(strstr(chainid,temp_sugar.r[ri].a[ai].cID) == NULL){
				check++;
				//chainid=strdup(temp_sugar.r[ri].a[ai].cID);
				//printf("The chain identifier is %s\n",temp_sugar.r[ri].a[ai].cID);
			}
			if(check==0){
				check1=1;
				r.na++;
				r.a=(atom*)realloc(r.a,(r.na*sizeof(atom)));
				r.a[r.na-1]=temp_sugar.r[ri].a[ai];
			}
		}
		
		if(check1==1){
		sugar.nr++;
		sugar.r=(residue*)realloc(sugar.r,(sugar.nr*sizeof(residue)));
		//printf("reallocated\n");
		sugar.r[sugar.nr-1]=r;
		}
		//printf("copied\n");	
		//printf("check is %d\n",check);	
	}

//printf("The number of residues are %d\n",sugar.nr);
//printf("done\n");
//printf("m[0].nr should be >>>%d<<<\n",sugar.nr);
//fflush(stdout);
//dprint_molecule(&sugar,100);

return sugar;

}
